function cHat = lsq_poly_crf_mix(varargin)
M_ori = varargin{1};
I = varargin{2};
%I = I ./ max(I(:));
I = (I-0)./max(I-0,[],2);
I = mean(I, 1);
%base = -min(M_ori,[],2);!!!!
base = 0;
M_norm = (M_ori-base)./max(M_ori-base,[],2);
M = mean(M_norm, 1);
[M_height, M_width] = size(M);

color_str = 'rgbcm';
if nargin <= 2
    numOrder = 4;
else
    numOrder = varargin{3};
end

if nargin <= 3
    %the number of fractional terms, x^(1/2), x^(1/3),...
    numOrder2 = 1;
else
    numOrder2 = varargin{4};
end

%% Constrainted least square
C = zeros(M_width*M_height, numOrder+numOrder2);
d = zeros(M_width*M_height, 1);
for i = 1:M_width
    for j = 1:numOrder
        C(((i-1)*M_height+1):i*M_height, j) = M(:, i).^(j);
    end
    
    for j = 1:numOrder2
        C(((i-1)*M_height+1):i*M_height, numOrder+j) = M(:, i).^(1/(j+1));
    end
    d(((i-1)*M_height+1):i*M_height, 1) = ones(M_height, 1) * I(i);
end

%First constraint is sum of coefficients add to 1. ie: g(1) =1
Aeq(1,1:numOrder+numOrder2) = 1; beq(1) = 1;

%Monotonic Constraint as Positive first derivative
step = 0:0.01:1;
% for i = 2:length(step)
%     %monotonous constraint
%     for j = 1:numOrder
%         A1(i-1,j) = -(1/j)*power(step(i),1/j-1);
%         A2(i-1,j) = -(1/j-1)*(1/j)*power(step(i),1/j-2);
%     end
%     %convex constraint
%     b1(i-1,1) = 0;
%     b2(i-1,1) = 0;
% end
% A1 = A1/max(abs(A1(:)));
% A2 = A2/max(abs(A2(:)));
A1 = zeros(length(step)-1,numOrder+numOrder2);
for i = 1:numOrder
    A1(:,i) = step(1:end-1).^i-step(2:end).^i;
end

for i = 1:numOrder2
    A1(:,i+numOrder) = step(1:end-1).^(1/(i+1))-step(2:end).^(1/(i+1));
end
b1 = zeros(length(step)-1,1); 

diff_v = diff(M(1,2:end-1),2);
if abs(sum(diff_v)) < 1e-4
    sig = 0;
else
    if length(diff_v(diff_v>0))/length(diff_v(diff_v<0))>1.5
        sig = 1;
    elseif length(diff_v(diff_v<0))/length(diff_v(diff_v>0))>1.5
        sig = -1;
    elseif length(diff_v(diff_v<0))/length(diff_v)>0.3 && length(diff_v(diff_v>0))/length(diff_v)>0.3
        sig = 0;
%         if length(I(1,2:end-1)>M(1,2:end-1))/length(M(1,2:end-1))>=0.9 
%             sig = -1;
%         elseif length(I(1,2:end-1)<M(1,2:end-1))/length(M(1,2:end-1))>=0.9 
%             sig = 1;
%         else
%             sig = 0;
%         end
    end
end

%Aneq = [A1; -sig*A2];
%bneq = [b1; -sig*b2];
Aneq = [A1];
bneq = [b1];

options = optimoptions('lsqlin','Algorithm','interior-point','Display','off');
[cHat]=lsqlin(C,d,Aneq,bneq,Aeq,beq,[],[],[],options);
cHat = [flip(cHat); 0];

%% Draw
% h_11 = figure(1);
%   set(h_11, 'Position', [100 500 450 400]);
%   plot(M, I, 'go', 'MarkerSize', 2, 'MarkerFaceColor', 'g', 'LineWidth', 2)
%   hold on
%   txt = 0; 
%   for i = 1:numOrder2
%   txt = txt + cHat(i)*linspace(0,1,100).^(1/(numOrder2-i+2));
%   end
%   for i = 1:numOrder
%   txt = txt + cHat(i+numOrder2)*linspace(0,1,100).^(numOrder-i+1);
%   end
% %   plot(linspace(0, 1, 100),...
% %        txt,...
% %        'b--', 'LineWidth', 2)
%   grid on, axis([0 1 0 1])
%   hold on
% %   plot(linspace(0, 1, 100),...
% %        polyval([1 0], linspace(0, 1, 100)),...
% %        'k--', 'LineWidth', 1)
%   set(gca, 'XTick', 0:0.1:1);
%   set(gca, 'YTick', 0:0.1:1);
%   xlabel('Normalized observation');
%   ylabel('Normalized irradiance');
end